diff -r 070513d25b63 tools/ngs_rna/tophat_wrapper.xml
--- a/tools/ngs_rna/tophat_wrapper.xml	Thu Oct 20 10:24:19 2011 -0400
+++ b/tools/ngs_rna/tophat_wrapper.xml	Thu Oct 20 08:38:42 2011 -0700
@@ -1,7 +1,8 @@
-<tool id="tophat" name="Tophat for Illumina" version="1.5.0">
+<tool id="tophat" name="Tophat" version="1.2.1">
     <description>Find splice junctions using RNA-seq data</description>
-    <version_command>tophat --version</version_command>
     <requirements>
+        <requirement type="package">samtools</requirement>
+        <requirement type="package">bowtie</requirement>
         <requirement type="package">tophat</requirement>
     </requirements>
     <command interpreter="python">
@@ -17,14 +18,18 @@
             #if $refGenomeSource.genomeSource == "history":
                 --own-file=$refGenomeSource.ownFile
             #else:
-                --indexes-path="${ filter( lambda x: str( x[0] ) == str( $refGenomeSource.index ), $__app__.tool_data_tables[ 'tophat_indexes' ].get_fields() )[0][-1] }"
+                #if $refGenomeSource.genomeSource == "indexed":
+                    --indexes-path="${ filter( lambda x: str( x[0] ) == str( $refGenomeSource.index ), $__app__.tool_data_tables[ 'tophat_indexes' ].get_fields() )[0][-1] }"
+                #else:
+                    --indexes-path="${ filter( lambda x: str( x[0] ) == str( $singlePaired.input1.metadata.dbkey ), $__app__.tool_data_tables[ 'tophat_indexes' ].get_fields() )[0][-1] }"
+                #end if
             #end if
 
             ## Are reads single-end or paired?
             --single-paired=$singlePaired.sPaired
 
             ## First input file always required.
-            --input1=$input1
+            --input1=$singlePaired.input1
 
             ## Set params based on whether reads are single-end or paired.
             #if $singlePaired.sPaired == "single":
@@ -52,7 +57,15 @@
                     ## Supplying junctions parameters.
                     #if $singlePaired.sParams.own_junctions.use_junctions == "Yes":
                         #if $singlePaired.sParams.own_junctions.gene_model_ann.use_annotations == "Yes":
-                            -G $singlePaired.sParams.own_junctions.gene_model_ann.gene_annotation_model
+                                #if $singlePaired.sParams.own_junctions.gene_model_ann.annotationSource.reference_annotation_file == "indexed":
+                                     -G "${ filter( lambda x: str( x[0] ) == str( $refGenomeSource.index ), $__app__.tool_data_tables[ 'gtf_index' ].get_fields() )[0][-1] }"
+                                #else:
+                                     #if $singlePaired.sParams.own_junctions.gene_model_ann.annotationSource.reference_annotation_file == "attribute":
+                                           -G "${ filter( lambda x: str( x[0] ) == str( $singlePaired.input1.metadata.dbkey ), $__app__.tool_data_tables[ 'gtf_index' ].get_fields() )[0][-1] }"
+                                     #else
+                                           -G "${singlePaired.sParams.own_junctions.gene_model_ann.annotationSource.owngtfFile}"
+                                     #end if
+                                #end if
                         #end if
                         #if $singlePaired.sParams.own_junctions.raw_juncs.use_juncs == "Yes":
                             -j $singlePaired.sParams.own_junctions.raw_juncs.raw_juncs
@@ -111,7 +124,15 @@
                     ## Supplying junctions parameters.
                     #if $singlePaired.pParams.own_junctions.use_junctions == "Yes":
                         #if $singlePaired.pParams.own_junctions.gene_model_ann.use_annotations == "Yes":
-                            -G $singlePaired.pParams.own_junctions.gene_model_ann.gene_annotation_model
+                                #if $singlePaired.pParams.own_junctions.gene_model_ann.annotationSource.reference_annotation_file == "indexed":
+                                     -G "${ filter( lambda x: str( x[0] ) == str( $refGenomeSource.index ), $__app__.tool_data_tables[ 'gtf_index' ].get_fields() )[0][-1] }"
+                                #else:
+                                     #if $singlePaired.pParams.own_junctions.gene_model_ann.annotationSource.reference_annotation_file == "attribute":
+                                           -G "${ filter( lambda x: str( x[0] ) == str( $singlePaired.input1.metadata.dbkey ), $__app__.tool_data_tables[ 'gtf_index' ].get_fields() )[0][-1] }"
+                                     #else
+                                           -G "${singlePaired.sParams.own_junctions.gene_model_ann.annotationSource.owngtfFile}"
+                                     #end if
+                                #end if
                         #end if
                         #if $singlePaired.pParams.own_junctions.raw_juncs.use_juncs == "Yes":
                             -j $singlePaired.pParams.own_junctions.raw_juncs.raw_juncs
@@ -145,18 +166,15 @@
             #end if
     </command>
     <inputs>
-        <param format="fastqsanger" name="input1" type="data" label="RNA-Seq FASTQ file" help="Nucleotide-space: Must have Sanger-scaled quality values with ASCII offset 33" />
         <conditional name="refGenomeSource">
           <param name="genomeSource" type="select" label="Will you select a reference genome from your history or use a built-in index?" help="Built-ins were indexed using default options">
             <option value="indexed">Use a built-in index</option>
             <option value="history">Use one from the history</option>
+            <option value="attribute">Use input fastq metadata.dbkey attribute</option>
           </param>
           <when value="indexed">
             <param name="index" type="select" label="Select a reference genome" help="If your genome of interest is not listed, contact the Galaxy team">
-              <options from_data_table="tophat_indexes">
-                <filter type="sort_by" column="2"/>
-                <validator type="no_options" message="No indexes are available for the selected input dataset"/>
-              </options>
+              <options from_data_table="tophat_indexes" />
             </param>
           </when>
           <when value="history">
@@ -169,6 +187,7 @@
               <option value="paired">Paired-end</option>
             </param>
             <when value="single">
+              <param format="fastqsanger" name="input1" type="data" label="RNA-Seq FASTQ file" help="Must have Sanger-scaled quality values with ASCII offset 33"/>
               <conditional name="sParams">
                 <param name="sSettingsType" type="select" label="TopHat settings to use" help="You can use the default settings or set custom values for any of Tophat's parameters.">
                   <option value="preSet">Use Defaults</option>
@@ -218,7 +237,16 @@
                              </param>
                              <when value="No" />
                              <when value="Yes">
-                               <param format="gtf" name="gene_annotation_model" type="data" label="Gene Model Annotations" help="TopHat will use the exon records in this file to build a set of known splice junctions for each gene, and will attempt to align reads to these junctions even if they would not normally be covered by the initial mapping."/>
+                               <conditional name="annotationSource">
+                                 <param name="reference_annotation_file" type="select" label="Please select a reference Aonnotation">
+                                   <option value="indexed">Use a built-in index</option>
+                                   <option value="history">Use one from the history</option>
+                                   <option value="attribute">Use metadata.bkey attribute from input fastq file</option>
+                                 </param>
+                                 <when value="history">
+                                   <param name="owngtfFile" type="data" format="gff3, gtf" label="Select a reference annotation file" />
+                                 </when>
+                               </conditional>
                              </when>
                           </conditional>
                           <conditional name="raw_juncs">
@@ -263,7 +291,7 @@
                         <param name="max_coverage_intron" type="integer" value="20000" label="Maximum intron length that may be found during coverage search" />
                     </when>
                     <when value="No" />
-                  </conditional>
+                  </conditional>     
                   <param name="microexon_search" type="select" label="Use Microexon Search" help="With this option, the pipeline will attempt to find alignments incident to microexons. Works only for reads 50bp or longer.">
                     <option value="No">No</option>
                     <option value="Yes">Yes</option>
@@ -272,7 +300,8 @@
               </conditional>  <!-- sParams -->
             </when>  <!--  single -->
             <when value="paired">
-              <param format="fastqsanger" name="input2" type="data" label="RNA-Seq FASTQ file" help="Nucleotide-space: Must have Sanger-scaled quality values with ASCII offset 33" />
+              <param format="fastqsanger" name="input1" type="data" label="RNA-Seq FASTQ file" help="Must have Sanger-scaled quality values with ASCII offset 33"/>
+              <param format="fastqsanger" name="input2" type="data" label="RNA-Seq FASTQ file" help="Must have Sanger-scaled quality values with ASCII offset 33"/>
               <param name="mate_inner_distance" type="integer" value="20" label="Mean Inner Distance between Mate Pairs" />
               <conditional name="pParams">
                 <param name="pSettingsType" type="select" label="TopHat settings to use" help="For most mapping needs use Commonly used settings. If you want full control use Full parameter list">
@@ -323,7 +352,16 @@
                              </param>
                              <when value="No" />
                              <when value="Yes">
-                               <param format="gtf" name="gene_annotation_model" type="data" label="Gene Model Annotations" help="TopHat will use the exon records in this file to build a set of known splice junctions for each gene, and will attempt to align reads to these junctions even if they would not normally be covered by the initial mapping."/>
+                               <conditional name="annotationSource">
+                                 <param name="reference_annotation_file" type="select" label="Please select a reference Aonnotation">
+                                   <option value="indexed">Use a built-in index</option>
+                                   <option value="history">Use one from the history</option>
+                                   <option value="attribute">Use metadata.bkey attribute from input fastq files</option>
+                                 </param>
+                                 <when value="history">
+                                   <param name="owngtfFile" type="data" format="gff3, gtf" label="Select a reference annotation file" />
+                                 </when>
+                               </conditional>
                              </when>
                           </conditional>
                           <conditional name="raw_juncs">
@@ -387,7 +425,7 @@
                       ( singlePaired['sParams']['indel_search']['allow_indel_search'] == 'Yes' ) ) or 
                     ( ( 'pParams' in singlePaired ) and ( 'indel_search' in singlePaired['pParams'] ) and 
                       ( singlePaired['pParams']['indel_search']['allow_indel_search'] == 'Yes' ) )
-                )
+                ) 
             </filter>
             <actions>
               <conditional name="refGenomeSource.genomeSource">
@@ -475,49 +513,46 @@
     </outputs>
 
     <tests>
-        <!-- Test base-space single-end reads with pre-built index and preset parameters -->
+        <!-- Test single-end reads with pre-built index and preset parameters -->
         <test>
             <!-- TopHat commands:
-            tophat -o tmp_dir -p 1 tophat_in1 test-data/tophat_in2.fastqsanger
-            Rename the files in tmp_dir appropriately
+            tophat -o tmp_dir -p 1 /afs/bx.psu.edu/depot/data/genome/test/tophat/tophat_in1 test-data/tophat_in2.fastqsanger
             -->
-            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger" />
             <param name="genomeSource" value="indexed" />
             <param name="index" value="tophat_test" />
             <param name="sPaired" value="single" />
+            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger" />
             <param name="sSettingsType" value="preSet" />
             <output name="junctions" file="tophat_out1j.bed" />
             <output name="accepted_hits" file="tophat_out1h.bam" compare="sim_size" />
         </test>
-        <!-- Test using base-space test data: paired-end reads, index from history. -->
+        <!-- Test using test data: paired-end reads, index from history. -->
         <test>
             <!-- TopHat commands:
             bowtie-build -f test-data/tophat_in1.fasta tophat_in1
             tophat -o tmp_dir -p 1 -r 20 tophat_in1 test-data/tophat_in2.fastqsanger test-data/tophat_in3.fastqsanger
-            Rename the files in tmp_dir appropriately
             -->
-            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger" />
             <param name="genomeSource" value="history" />
             <param name="ownFile" ftype="fasta" value="tophat_in1.fasta" />
             <param name="sPaired" value="paired" />
+            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger" />
             <param name="input2" ftype="fastqsanger" value="tophat_in3.fastqsanger" />
             <param name="mate_inner_distance" value="20" />
             <param name="pSettingsType" value="preSet" />
             <output name="junctions" file="tophat_out2j.bed" />
             <output name="accepted_hits" file="tophat_out2h.bam" compare="sim_size" />
         </test>
-        <!-- Test base-space single-end reads with user-supplied reference fasta and full parameters -->
+        <!-- Test single-end reads with user-supplied reference fasta and full parameters -->
         <test>
             <!-- Tophat commands:
             bowtie-build -f test-data/tophat_in1.fasta tophat_in1
             tophat -o tmp_dir -p 1 -a 8 -m 0 -i 70 -I 500000 -F 0.15 -g 40 +allow-indels +coverage-search +min-coverage-intron 50 +max-coverage-intro 20000 +segment-mismatches 2 +segment-length 25 +closure-search +min-closure-exon 50 +min-closure-intron 50 +max-closure-intro 5000 +microexon-search tophat_in1 test-data/tophat_in2.fastqsanger
             Replace the + with double-dash
-            Rename the files in tmp_dir appropriately
             -->
-            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger"/>
             <param name="genomeSource" value="history"/>
             <param name="ownFile" value="tophat_in1.fasta"/>
             <param name="sPaired" value="single"/>
+            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger"/>
             <param name="sSettingsType" value="full"/>
             <param name="library_type" value="FR Unstranded"/>
             <param name="anchor_length" value="8"/>
@@ -550,17 +585,16 @@
             <output name="junctions" file="tophat_out3j.bed" />
             <output name="accepted_hits" file="tophat_out3h.bam" compare="sim_size" />
         </test>
-        <!-- Test base-space paired-end reads with user-supplied reference fasta and full parameters -->
+        <!-- Test paired-end reads with user-supplied reference fasta and full parameters -->
         <test>
             <!-- TopHat commands:
-            tophat -o tmp_dir -r 20 -p 1 -a 8 -m 0 -i 70 -I 500000 -F 0.15 -g 40 +coverage-search +min-coverage-intron 50 +max-coverage-intro 20000 +segment-mismatches 2 +segment-length 25 +closure-search +min-closure-exon 50 +min-closure-intron 50 +max-closure-intron 5000 +microexon-search tophat_in1 test-data/tophat_in2.fastqsanger test-data/tophat_in3.fastqsanger
+            tophat -o tmp_dir -r 20 -p 1 -a 8 -m 0 -i 70 -I 500000 -F 0.15 -g 40 +coverage-search +min-coverage-intron 50 +max-coverage-intro 20000 +segment-mismatches 2 +segment-length 25 +closure-search +min-closure-exon 50 +min-closure-intron 50 +max-closure-intron 5000 +microexon-search /afs/bx.psu.edu/depot/data/genome/test/tophat/tophat_in1 test-data/tophat_in2.fastqsanger test-data/tophat_in3.fastqsanger
             Replace the + with double-dash
-            Rename the files in tmp_dir appropriately
             -->
-            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger"/>
             <param name="genomeSource" value="indexed"/>
             <param name="index" value="tophat_test"/>
             <param name="sPaired" value="paired"/>
+            <param name="input1" ftype="fastqsanger" value="tophat_in2.fastqsanger"/>
             <param name="input2" ftype="fastqsanger" value="tophat_in3.fastqsanger"/>
             <param name="mate_inner_distance" value="20"/>
             <param name="pSettingsType" value="full"/>
@@ -628,9 +662,7 @@
 
 .. _BED: http://genome.ucsc.edu/FAQ/FAQformat.html#format1
 .. _BAM: http://samtools.sourceforge.net/
-
-Two other possible outputs, depending on the options you choose, are insertions and deletions, both of which are in BED format.
-
+    
 -------
 
 **Tophat settings**
@@ -649,7 +681,7 @@
   --mate-std-dev INT                The standard deviation for the distribution on inner distances between mate pairs. The default is 20bp.
   -a/--min-anchor-length INT        The "anchor length". TopHat will report junctions spanned by reads with at least this many bases on each side of the junction. Note that individual spliced     
                                     alignments may span a junction with fewer than this many bases on one side. However, every junction involved in spliced alignments is supported by at least one 
-                                    read with this many bases on each side. This must be at least 3 and the default is 8.
+                                    read with this many bases on each side.  This must be at least 3 and the default is 8.
   -m/--splice-mismatches INT        The maximum number of mismatches that may appear in the "anchor" region of a spliced alignment. The default is 0.
   -i/--min-intron-length INT        The minimum intron length. TopHat will ignore donor/acceptor pairs closer than this many bases apart. The default is 70.
   -I/--max-intron-length INT        The maximum intron length. When searching for junctions ab initio, TopHat will ignore donor/acceptor pairs farther than this many bases apart, except when such a pair is supported by a split segment alignment of a long read. The default is 500000.
